#pragma once

#include <windows.h>

class Ecran
{
	HDC m_hdc;
	HWND m_hWnd;
	RECT	m_rect;
	PAINTSTRUCT m_ps;

public:
	Ecran(HWND hWnd) : m_hWnd( hWnd)
	{ 
		GetClientRect(hWnd, &m_rect);

		m_hdc = BeginPaint(hWnd, &m_ps);
	}
	~Ecran()
	{
		EndPaint(m_hWnd, &m_ps);
	}
	void dessineTrait( int x1, int y1, int x2, int y2 )
	{
		POINT p ;

		MoveToEx(m_hdc, x1,m_rect.bottom-m_rect.top -y1, &p);
		LineTo(m_hdc, x2, m_rect.bottom-m_rect.top -y2 );
	}
	int getXCentre() const{ return (m_rect.bottom-m_rect.top)/2 ; }
	int getYCentre() const{ return (m_rect.right-m_rect.left)/2 ; }
};


void dessine(HWND hWnd);
