// Tortue.h: interface for the Tortue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TORTUE_H__4CF51E76_232B_422F_ABAF_8E5DFBAA5E46__INCLUDED_)
#define AFX_TORTUE_H__4CF51E76_232B_422F_ABAF_8E5DFBAA5E46__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "globals.h"

class Ecran;

class Tortue  
{
public:
	Tortue(Ecran * ecran, double x, double y);
	virtual ~Tortue();

	void avance(TypeParametre distance);
	void tourne(TypeParametre angle);

	TypeParametre getPositionX();
	TypeParametre getPositionY();
protected:
	// Definition de la position et de l'angle de vue
	TypeParametre m_X;
	TypeParametre m_Y;
	TypeParametre m_Angle;

	// L'cran sur lequel on affiche
	Ecran* m_Ecran;
};

#endif // !defined(AFX_TORTUE_H__4CF51E76_232B_422F_ABAF_8E5DFBAA5E46__INCLUDED_)
