// tri_a_partir_de_fichier.cpp : dfinit le point d'entre pour l'application console.
//

#include "stdafx.h"

typedef pair<string, int>	TypeLigne;
typedef list<TypeLigne>	TypeCollec;

bool tri_paires( const TypeLigne & l1, const TypeLigne & l2 )
{
	return l1.second < l2.second;
}

void print_ligne( const TypeLigne & l )
{
	cout << l.first << " - " << l.second << '\n';
}

void tri_sans_iterateur( TypeCollec & collec_triee )
{
	ifstream					file("data.txt");
	
	while( ! file.eof() ){
		TypeLigne	ligne;

		file >> ligne.first ;
		if ( file.eof() )
			break;
		file >> ligne.second ;
		if ( file.eof() )
			break;

		collec_triee.push_back(ligne);
	}
	collec_triee.sort(tri_paires);
}

void tri_avec_iterateur( TypeCollec & collec_triee )
{
	ifstream					file("data.txt");
	istream_iterator<string>	it(file);
	istream_iterator<string>	end;
	
	for( ; it != end; it++){
		TypeLigne	ligne;
		ligne.first = *it;
		it++;
		stringstream s ;
		//string x = *it;
		s << *it;

		s >> ligne.second ;
			
		collec_triee.push_back(ligne);
	}
	collec_triee.sort(tri_paires);
}


void main()
{
	TypeCollec collec_triee;
	tri_sans_iterateur( collec_triee);
	for_each(collec_triee.begin(), collec_triee.end(), print_ligne );
	
	cout << "*************************************\n";

	collec_triee.clear();
	tri_avec_iterateur( collec_triee );
	for_each(collec_triee.begin(), collec_triee.end(), print_ligne );

}

