/* les Namespaces 

 Exercice
 o Placer les struct, variables globales , et fonctions dans un namespace BST
 o Ne mettre que les "declarations" dans la dfinition du namespace .
	Placer les "definitions" au niveau de scope zero.
	Y compris la dfinition du Ctor de Node
 o Modifier le "main()" si ncessaire
 O Sparer ensuite le rsultat en trois fichiers:
	main.cpp, bst.h et bst.cpp
*/

#include <iostream>
#include <ctime>
using namespace std;

struct Node {
   Node( int v ) { value = v;  left = rite = 0; }
   int value;
   Node* left;
   Node* rite;
};

Node* root = 0;

void add( Node** n, int v ) {
   if ( ! *n)                 *n = new Node( v );
   else if (v <= (*n)->value) add( &((*n)->left), v );
   else                       add( &((*n)->rite), v );
}

void add( int v ) { add( &root, v ); }

void traverse( Node* n ) {
   if (n->left) traverse( n->left );
   cout << n->value << ' ';
   if (n->rite) traverse( n->rite );
}

void main( void ) {
   srand( time( 0 ) );
   for (int i=0; i < 20; i++)
      add( rand() % 20 + 1 );
   traverse( root );
   cout << '\n';
}

// 1 2 3 3 3 4 4 5 5 8 9 9 9 10 10 11 12 15 17 20
