//   Namespace  : solution

#include <iostream>
#include <ctime>
using namespace std;


namespace BST {
   struct Node {
      Node( int );
      int value;
      Node* left;
      Node* rite;
   };
   Node* root = 0;
   void add( Node**, int );
   void add( int );
   void traverse( Node* );
}

void main( void ) {
   srand( time( 0 ) );
   for (int i=0; i < 20; i++)
      BST::add( rand() % 20 + 1 );
   BST::traverse( BST::root );
   cout << '\n';
}

// 1 2 3 3 3 4 4 5 5 8 9 9 9 10 10 11 12 15 17 20

BST::Node::Node( int v ) { value = v;  left = rite = 0; }

void BST::add( Node** n, int v ) {
   if ( ! *n)                 *n = new Node( v );
   else if (v <= (*n)->value) add( &((*n)->left), v );
   else                       add( &((*n)->rite), v );
}

void BST::add( int v ) { add( &root, v ); }

void BST::traverse( Node* n ) {
   if (n->left) traverse( n->left );
   cout << n->value << ' ';
   if (n->rite) traverse( n->rite );
}



#if 0

namespace BST {
   struct Node;
   extern Node* root;
   void add( Node** n, int v );
   void add( int v );
   void traverse( Node* n );
}

struct BST::Node {
   Node( int v ) { value = v;  left = rite = 0; }
   int value;
   Node* left;
   Node* rite;
};

BST::Node* BST::root = 0;

void BST::add( BST::Node** n, int v ) {
   if ( ! *n)                 *n = new Node( v );
   else if (v <= (*n)->value) add( &((*n)->left), v );
   else                       add( &((*n)->rite), v );
}

void BST::add( int v ) { add( &root, v ); }

void BST::traverse( BST::Node* n ) {
   if (n->left) traverse( n->left );
   cout << n->value << ' ';
   if (n->rite) traverse( n->rite );
}

#endif
