// Purpose.  Preprocessor macro versus function template lab
//
// Discussion.  "Function templates have, among other things, the following
// characteristics that macros do not have:" [Vandevoorde, pp153-154]
//    o Their instantiations have linkage
//    o They obey scoping rules (for example, a template may be visible only
//      inside a namespace)
//    o There can be pointers to function template specializations
//    o They can be overloaded or specialized
//    o They can be recursive
//
// Assignment.
// o Try both countDown1 and countDown2
// o Convert countDown2 to a function template defined inside a namespace
//   "Separate"
// o Define a template specialization in namespace Separate that accepts a
//   double parameter and invokes an int version of countDown3

// countDown est OK mais pas countDown2
// Le problme est la rcursivit de countDown2 => pas expans
// de plus, il y a un warning d  la convertion d'un double en int
// le template est immdiat 
// sans la spcialisation, le compteur fait 5.4 4.4 3.4 2.4 1.4 0.4 !
// la spcialisation est une fonction de conversion

#include <iostream>
using namespace std;

#define countDown1( X ) {        \
   for (int i = (X); i > 0; i--) \
      cout << i << ' ';          \
}

#define countDown2( X ) {            \
   cout << (X) << '\n';              \
   if ((X) > 1) countDown2( (X)-1 ); \
}

void main( void ) {
    countDown1( 5.4 );
	//countDown2( 5.4 );
    Separate::countDown3( 5.4 );
   cout << '\n';
}

// 5 4 3 2 1
