// Purpose.  template wrapper lab
//
// Assignment.
// o Take your loggingWrapper answer and decouple class Logger from class Object
//   (make Logger a template class)
// o Eliminate the "master base class in the sky" Object class
// o Massage the code in main() as necessary
// o What is the only requirement that Logger<T> puts on objects that it wraps?

// inclusion des classes Object et Logger
// templatiser la classe Logger pour paramtrer le type Object 
// modifier le "main" pour utiliser les types templates
// tester
// retirer la classe Objet ainsi que l'hritage Object de Derived
// on pourra remplacer Object par une interface ILoggable
// de toutes faons, si une classe est utilise sans fournir les mthodee getString et Execute
// il y a une erreur de compilation

// inclusion de la classe loggingWrapper
#include <iostream>
#include <string>
using namespace std;

/*class Object { public:
   virtual ~Object() { }
   virtual string getString() = 0;
   virtual void   execute()   = 0;
};*/

class Derived //: public Object 
{
   string str;
public:
   Derived( string s )            { str = s; }
   /*virtual*/ ~Derived()         { cout << "dtor - " << str << "   "; }
   /*virtual*/ string getString() { return str; }
   /*virtual*/ void   execute()   { cout << "exec - " << str << '\n'; }
};
class Derived2
{
   string str;
public:
   Derived2( string s )            { str = s; }
   /*virtual*/ ~Derived2()         { cout << "dtor - " << str << "   "; }
   /*virtual*/ void   execute()   { cout << "exec - " << str << '\n'; }
};

void main( void ) {
   Logger<Derived>* array[] = { new Logger<Derived>( new Derived( "one" ) ),
                       new Logger<Derived>( new Derived( "two" ) ),
                       new Logger<Derived>( new Derived( "thr" ) ) };
   for (int i=0; i < 3; i++)
      (*(array[i]))->execute();

   Logger<Derived2>* array2[] = { new Logger<Derived2>( new Derived2( "one" ) ),
                       new Logger<Derived2>( new Derived2( "two" ) ),
                       new Logger<Derived2>( new Derived2( "thr" ) ) };
   for (int i=0; i < 3; i++)
      (*(array2[i]))->execute();
   for (i=0; i < 3; i++) delete array2[i];

   for (i=0; i < 3; i++) delete array[i];
   cout << endl;
}
// fin d'inclusion de la classe loggingWrapper

// clog - one   exec - one
// clog - two   exec - two
// clog - thr   exec - thr
// dtor - one   dtor - two   dtor - thr
