// Purpose.  Template and operator-> lab answer

#include <iostream>
using namespace std;

void prefix() { cout << "prefix "; }
void suffix() { cout << " suffix\n"; }

template <typename TBD>
class BeforeAfter {
   TBD* ptr;

   class After {
      TBD* ptr;
   public:
      After( TBD* p ) { ptr = p; }
      ~After() { suffix(); }
      TBD* operator-> () { return ptr; }
   };

public:
   BeforeAfter( TBD* p ) { ptr = p; }
   ~BeforeAfter()        { delete ptr; }
   After operator-> () {
      prefix();
      return After( ptr ); }
};

class X {
public:
   bool f() { cout << "X::f()"; return true; }
};

class Y {
public:
   void g() { cout << "Y::g()"; }
};

void main( void ) {
   BeforeAfter<X> wrapperObject1( new X() );
   if (wrapperObject1->f()) cout << "f() is true\n";
   BeforeAfter<Y> wrapperObject2( new Y() );
   wrapperObject2->g();
}

// prefix X::f() suffix
// f() is true
// prefix Y::g() suffix
