// Purpose.  Template lab answer

#include <iostream>
#include <string>
using namespace std;

template <typename TYP>
class BST {
   struct Node {
      Node( TYP v ) { value = v;  count = 0;  left = rite = 0; }
      TYP value;
      int count;
      Node* left;
      Node* rite;
   };
   Node* root;
   int& add( Node**, TYP );
   void traverse( Node* );
public:
   BST() { root = 0; }
   int& operator[] ( TYP v );
   void traverse();
};

void main( void ) {
   BST<string> one;
   string str;
   cout << "Input: ";
   while (true) {
      cin >> str;
      if (str == "quit") break;
      one[ str ]++;
   }
   cout << "one: ";  one.traverse();
   cout << '\n';
}

// Input: the quick brown fox
// the quick cat is a fox
// the brown fox is quick quit
// one: a-1 brown-2 cat-1 fox-3 is-2 quick-3 the-3


// template <typename TYP>
// BST<TYP>::Node::Node( TYP v ) { value = v;  count = 0;  left = rite = 0; }

template <typename TYP>
int& BST<TYP>::add( Node** n, TYP v ) {
   if ( ! *n) {
      *n = new Node( v );
      return (*n)->count;
   }
   else if (v == (*n)->value) return (*n)->count;
   else if (v < (*n)->value)  return add( &((*n)->left), v );
   else                       return add( &((*n)->rite), v );
}

template <typename TYP>
int& BST<TYP>::operator[] ( TYP v ) { return add( &root, v ); }

template <typename TYP>
void BST<TYP>::traverse() { traverse( root ); }

template <typename TYP>
void BST<TYP>::traverse( Node* n ) {
   if (n->left) traverse( n->left );
   cout << n->value << '-' << n->count << ' ';
   if (n->rite) traverse( n->rite );
}
