// Purpose.  template wrapper lab answer

#include <iostream>
#include <string>
using namespace std;

template <typename TBD>
class Logger {
   TBD*  ptr;
public:
   Logger( TBD* p )   { ptr = p; }
   ~Logger()          { delete ptr; }
   TBD* operator-> () {
      clog << "clog - " << ptr->getString() << "   ";
      return ptr;
}  };

class Derived {
   string str;
public:
   Derived( string s )            { str = s; }
   /*virtual*/ ~Derived()         { cout << "dtor - " << str << "   "; }
   /*virtual*/ string getString() { return str; }
   /*virtual*/ void   execute()   { cout << "exec - " << str << '\n'; }
};

void main( void ) {
   Logger<Derived>* array[] = { new Logger<Derived>( new Derived( "one" ) ),
                                new Logger<Derived>( new Derived( "two" ) ),
                                new Logger<Derived>( new Derived( "thr" ) ) };
   for (int i=0; i < 3; i++)
      (*(array[i]))->execute();

   for (i=0; i < 3; i++) delete array[i];
   cout << endl;
}

// clog - one   exec - one
// clog - two   exec - two
// clog - thr   exec - thr
// dtor - one   dtor - two   dtor - thr
