// Purpose.  Preprocessor macro versus function template lab answer

#include <iostream>
using namespace std;

#define countDown1( X ) {        \
   for (int i = (X); i > 0; i--) \
      cout << i << ' ';          \
}

#define countDown2( X ) {            \
   cout << (X) << '\n';              \
   if ((X) > 1) countDown2( (X)-1 ); \
}

namespace Separate {
   template <typename TBD>
   countDown3( TBD count ) {
      cout << count << ' ';
      if (count > 1) countDown3( count-1 );
   }
   template <>
   countDown3( double count ) {
      countDown3<int>( count );
   }
}

void main( void ) {
   // countDown1( 5.4 );
   // countDown2( 5.4 );
   Separate::countDown3( 5.4 );
   cout << '\n';
}

// 5 4 3 2 1
