// Purpose.  remove_if => find_if lab answer

#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

class Nth {
   int nth, count;
public:
   Nth( int n )                { nth = n;  count = 0; }
   bool operator() ( int val ) { return ++count == nth; }
};

template <class ForwardIter, class UnaryPred>
ForwardIter my_remove_if( ForwardIter beg, ForwardIter end, UnaryPred op ) {
   while (beg != end  &&  !op(*beg))
      ++beg;
   if (beg == end)
      return beg;
   else {
      ForwardIter next = beg;
      return remove_copy_if( ++next, end, beg, op );
}  }

void main( void ) {
   list<int> array;
   for (int i=1; i < 14; i++)
      array.push_back( i );
   list<int>::iterator pos;
   pos = my_remove_if( array.begin(), array.end(), Nth(3) );
   array.erase( pos, array.end() );
   for (pos = array.begin(); pos != array.end(); pos++)
      cout << *pos << ' ';
   cout << '\n';
}

// 1 2 4 5 6 7 8 9 10 11 12 13
