// Purpose.  STL lab answer

#pragma warning( disable : 4786 )
#include <iostream>
#include <vector>
#include <string>
#include <sstream>
using namespace std;

template <typename TBD>
class Stack {
   vector<TBD> vec;
public:
   void push( TBD val ) { vec.push_back( val ); }
   bool isFull()        { return false; }
   bool isEmpty()       { return vec.size() == 0; }
   TBD  pop() {
      if (isEmpty()) return 0;
      TBD element = vec.back();
      vec.pop_back();
      return element;
}  };

void main( void ) {
   Stack<int>    s1;
   Stack<char>   s2;
   Stack<string> s3;
   stringstream  ss;
   for (int i=0; i < 13; i++) {
      s1.push( i );
      s2.push( 'a' + i );
      ss << "str" << i;
      s3.push( ss.str() );
      ss.str( "" );
   }
   while ( ! s1.isEmpty()) cout << s1.pop() << ' ';
   cout << '\n';
   while ( ! s2.isEmpty()) cout << s2.pop() << ' ';
   cout << '\n';
   while ( ! s3.isEmpty()) cout << s3.pop() << ' ';
   cout << '\n';
}

// 12 11 10 9 8 7 6 5 4 3 2 1 0
// m l k j i h g f e d c b a
// str12 str11 str10 str9 str8 str7 str6 str5 str4 str3 str2 str1 str0
