// Purpose.  auto_ptr initialization, usage, and cleanup lab
//
// Assignment.
// o Change the A* array in main() to an auto_ptr<A> array
// o Add a #include
// o Eliminate the last loop - it is no longer needed
// o Change as little else in main() as possible

#include <iostream>
using namespace std;

class A {
   int id;
   static int next;
public:
   A() { id = next++;  cout << 'A' << id << ' '; }
   ~A() { cout << 'd' << id << ' '; }
   void foo() { cout << "foo-" << id << ' '; }
};

int A::next = 1;

void main( void ) {
   A* array[3];
   for (int i=0; i < 3; i++)
      array[i] = new A();
   cout << '\n';
   for (i=0; i < 3; i++)
      array[i]->foo();
   cout << '\n';
   for (i=0; i < 3; i++)
      delete array[i];
   cout << '\n';
}

// A1 A2 A3
// foo-1 foo-2 foo-3
// d1 d2 d3

// A1 A2 A3
// foo-1 foo-2 foo-3
// d3 d2 d1 Press any key to continue
