// Purpose.  Operator, template function, and vector<T> lab answer

#pragma warning( disable : 4786 )
#include <iostream>
#include <vector>
#include <string>
#include <sstream>
using namespace std;

template <typename TYP>
ostream& operator<< ( ostream& os, const vector<TYP>& obj ) {
   os << "[ ";
   for (int i=0; i < obj.size(); i++)
      os << obj[i] << ' ';
   return os << ']';
}

template <typename TYP>
istream& operator>> ( istream& is, vector<TYP>& obj ) {
   char   buf[80];
   string str;
   is.getline( buf, 30 ); 
   stringstream ss( buf );
   while (ss >> str)
      obj.push_back( str );
   return is;
}

void main( void ) {
   vector<int>    one( 3, 4 );
   vector<string> two;
   cout << "one is " << one << '\n';
   cout << "Enter strings: ";
   cin >> two;
   cout << "two is " << two << '\n';
}

// one is [ 4 4 4 ]
// Enter strings: the quick brown fox
// two is [ the quick brown fox ]
