// Purpose.  Generic programming lab answer (template function)

#include <iostream>
#include <ctime>
using namespace std;

// Shell sort, Stroustrup, p334
template <typename TBD>
void sort( TBD v[], int n ) {
   for (int g = n/2; g > 0; g /= 2)
      for (int i = g; i < n; i++)
         for (int j = i-g; j >= 0; j -= g)
            if (v[j] > v[j+g]) {
               TBD temp = v[j];
               v[j] = v[j+g];
               v[j+g] = temp;
}           }

void main( void ) {
   srand( time(0) );
   const int NUM = 15;
   int array[NUM];
   for (int i=0; i < NUM; i++) array[i] = rand() % 20 + 1;
   sort( array, NUM );
   for (i=0; i < NUM; i++) cout << array[i] << ' ';
   cout << '\n';
}

// 1 1 4 4 5 8 9 11 11 13 15 18 20 20 20
