// Purpose.  Generic programming lab answer (custom strategy)

#pragma warning( disable : 4786 )
#include <iostream>
#include <vector>
#include <string>
#include <functional>
#include <ctime>
using namespace std;

template <typename TYP>
bool my_greater( TYP one, TYP two ) { return one > two; }

template <>
bool my_greater( string one, string two ) {
   for (int i= 0; i < one.size() && i < two.size(); i++)
      if (tolower(one[i]) == tolower(two[i]))
         ;
      else return tolower(one[i]) > tolower(two[i]);
   return one.size() > two.size();
}

template <typename TBD, typename COMP>
void sort( TBD v, TBD end, COMP func ) {
   int n = distance( v, end );
   for (int g = n/2; g > 0; g /= 2)
      for (int i = g; i < n; i++)
         for (int j = i-g; j >= 0; j -= g)
            if (func( v[j], v[j+g] ))
               swap( v[j], v[j+g] );
}

void main( void ) {
   srand( time(0) );
   vector<string> vec( 15 );
   char ch;
   for (int i=0; i < vec.size(); i++)
      for (int j=0; j < 4; j++) {
         ch = rand() % 26 + 65 + (rand()%2 ? 32 : 0);
         vec[i] += ch;
      }
   for (i=0; i < vec.size(); i++) cout << vec[i] << ' ';   cout << '\n';
   sort( vec.begin(), vec.end(), greater<string>() );
   for (i=0; i < vec.size(); i++) cout << vec[i] << ' ';   cout << '\n';
   sort( vec.begin(), vec.end(), my_greater<string> );
   for (i=0; i < vec.size(); i++) cout << vec[i] << ' ';   cout << '\n';
}

// hUSd soVN Xtmh DtBV lbxJ voho vWYN HrSu nxIa rsXL oDfB XLYw hGbC QANX Ujpa
// DtBV HrSu QANX Ujpa XLYw Xtmh hGbC hUSd lbxJ nxIa oDfB rsXL soVN vWYN voho
// DtBV hGbC HrSu hUSd lbxJ nxIa oDfB QANX rsXL soVN Ujpa voho vWYN XLYw Xtmh

// bCGP Qand pBxB jNHK lhev yyzV HmMT pxpS HPbW SqVT aDAo oDCJ CioH HJAx BPTs
// BPTs CioH HJAx HPbW HmMT Qand SqVT aDAo bCGP jNHK lhev oDCJ pBxB pxpS yyzV
// aDAo bCGP BPTs CioH HJAx HmMT HPbW jNHK lhev oDCJ pBxB pxpS Qand SqVT yyzV
