// Purpose.  Exception escaping from destructor lab
//
// Discussion.  Uncaught exceptions escaping from destructors will cause the
// current terminate() function to be called.  Once terminate() is called,
// there is no way that the application can be resurrected.
//
// Assignment.
// o Put a try/catch construct in A's destructor
// o The catch clause should catch every exception known to man

//utilisation de set_terminate pour vrifier l'chec et le tracer...
// ... voir le main
// simplement ajouter un bloc try...catch dans le Dtor

#include <iostream>
using namespace std;

class A {
public:
   A() { cout << "A ctor\n"; }
   ~A() {
// avant
//		cout << "dtor A\n";
//      throw 321;
         cout << "dtor A\n";
         throw 321;
   }  };


void foo() {
   A object;
   throw 123;
}

void main( void ) {

   try {
      foo();
   } catch (int ex) {
      cout << "exception - " << ex << '\n';
}  }

////////// current output //////////
// A ctor
// dtor A
// myTerminate: failed to catch exception

////////// desired output //////////
// A ctor
// dtor A
// exception almost slipped by
// exception - 123
