// Purpose.  Exception lab
//
// Assignment.
// o Take your stackTemplateLab answer and add Empty and Full public "inner"
//   classes (defined with an empty implementation)
// o Add exception specifications to push() and pop()
// o Throw Full in push() and Empty in pop() as necessary
// o Massage main() to catch exceptions and produce the output below

//Le but est de lancer les exceptions dans "push" et "pop"
//puis de les attraper dans le main. 

#include <iostream>
#include <string>
using namespace std;

template <typename TBD>
class Stack {
   TBD* array;
   int  sp, size;
public:

   Stack( int s = 10 )  { array = new TBD[s];  size = s;  sp = -1; }
   ~Stack()             { delete [] array; }
   //void push( TBD val ) { if ( ! isFull()) array[++sp] = val; }
   void push( TBD val ) {
      array[++sp] = val;   }
   //TBD  pop()           { if (isEmpty()) return 0;  return array[sp--]; }
   TBD pop() {
      return array[sp--];}
};

void main( int argc, char* argv[] ) {
   Stack<int> s;

	
  for (int i=0; i < 10; i++)
      s.push( i );
   if (argc == 2) s.push( i );
  for (i=0; i < 10; i++)
      cout << s.pop() << ' ';
   cout << '\n';
   if (argc == 3) s.pop();

   
}

// D:> advcpp
// 9 8 7 6 5 4 3 2 1 0
// normal flow of control
//
// D:> advcpp 2
// tried to push() a full stack
// normal flow of control
//
// D:> advcpp 2 3
// 9 8 7 6 5 4 3 2 1 0
// tried to pop() an empty stack
// normal flow of control
