// STL.cpp : dfinit le point d'entre pour l'application console.
//
#include "stdafx.h"
#include <list>
#include <vector>
#include <deque>
#include <algorithm>
#include <iostream>
#include <time.h>
using namespace std;

typedef deque<int> Collec;
typedef Collec::iterator IteratorCollec;
typedef Collec::iterator IteratorCollec;
typedef Collec::const_iterator ConstIteratorCollec;

void printEntier( int i )
{
		cout << i << endl;
}

void printCollec( const Collec & collec)
{
/*	for( ConstIteratorCollec i = collec.begin(); i != collec.end(); i++)
	{
		int x = * i;
		printEntier(x);
	}*/
	for_each( collec.begin(), collec.end(), printEntier );
}

struct Functor {
	int somme ;
	Functor( ) :somme(0){}	 
	void operator ()( int i )
	{
			if ( somme < 10 )
				cout << i << endl;
			somme += i;
	}
};

void Somme( const Collec & collec)
{
	Functor f;
	for_each( collec.begin(), collec.end(), f );
}

int main()
{
	const int SIZE = 100;
	Collec	collec;
	//collec.reserve(SIZE);

	for(int i =0; i<SIZE; i++)
		collec.push_back(i);
	
	Somme(collec);

	cout << "fin ajout : " << (long)time(0) << endl;
	printCollec( collec);
	cout << "fin parcours : " << (long)time(0) << endl;

	return 0;
}

