// maxi2.cpp : dfinit le point d'entre pour l'application console.
//
#include "stdafx.h"
#include <iostream>
#include <algorithm>
using namespace std;

template < class T >
T maxi( T x , T y )
{
	if ( x > y )
		return x;
	return y;
}

char* maxi( char* x , char* y )
{
	if ( strcmp( x , y) > 0  )
		return x;
	return y;
}

class Voiture{
	int m_vitesse;
public :
	Voiture( int vitesse ): m_vitesse( vitesse) {} ;
	bool operator > ( const Voiture& v2) const
	{
		return m_vitesse > v2.m_vitesse;
	}
	friend ostream & operator << ( ostream & os, const Voiture & v );
};

ostream & operator << ( ostream & os, const Voiture & v )
{
	os << "Voiture (" << v.m_vitesse << ")";
	return os;
}


int _tmain(int argc, _TCHAR* argv[])
{
	int i=1,j=2;
	cout << maxi(i,j) << endl;;   // maxi <int>(i,j)
	double d1=1.,d2=.5; 	
	cout << maxi(d1,d2) << endl;;   // maxi <int>(i,j)	
	cout << maxi("paul","pierre") << endl;	//maxi <char*> (pierre,paul)
	Voiture deuxChevaux( 100);
	Voiture polo( 170 );

	cout << maxi( deuxChevaux, polo ) << endl;
	return 0;
}

