// istream_iterator.cpp : dfinit le point d'entre pour l'application console.
//

#include "stdafx.h"
#include <fstream>
#include <string>
#include <iostream>
#include <algorithm>
using namespace std;


bool recherche1( const string & t )
{
	return t == "toto";
}

struct Recherche2{
	string valeur;
	Recherche2( const string & s)
		: valeur(s)
	{
	}
	bool operator()( const string & s ) const  
	{
		return s == valeur;
	}
};

void test_recherche1()
{
	ifstream file("texte.txt");
	istream_iterator<string> it(file);
	istream_iterator<string> end , debut = it;

	istream_iterator<string> resultat = find_if(it, end, recherche1);
	
	if ( resultat != end){
		cout << " trouve !\n" ;
	}else
		cout << "pas trouve\n";
}

void test_recherche2()
{
	ifstream file("texte.txt");
	istream_iterator<string> it(file);
	istream_iterator<string> end ;
	istream_iterator<string> debut(file) ;

	Recherche2 r2("toto");
	istream_iterator<string> resultat = find_if(it, end, r2);
	
	if ( resultat != end){
		cout << " trouve !\n" ;

	}else
		cout << "pas trouve\n";
}

int main()
{
	// avec une fonction paramtre
	test_recherche1();
	// avec un functor
	test_recherche2();
}

