// Purpose.  Template lab
//
// Assignment.
// o Convert StackInt into a template class
// o Replace the top main() with the bottom main()
// o Declare three different "stack" objects

// Modifier la classe StackInt en template Stack (ne pas oublier les Ctor/Dtor
//Que signifie le membre "sp" ? c'est un indicateur de profondeur
// il vaut -1 si la pile est vide et size-1 lorsqu'elle est pleine

#include <iostream>
#include <string>
#include <sstream>
using namespace std;


class StackInt {
   int* array;
   int  sp, size;
public:
   StackInt( int s = 10 ) { array = new int[s];  size = s;  sp = -1; }
   ~StackInt()            { delete [] array; }
   void push( int val )   { if ( ! isFull()) array[++sp] = val; }
   int  pop()             { if (isEmpty()) return 0;  return array[sp--]; }
   bool isFull()          { return sp == size-1; }
   bool isEmpty()         { return sp == -1; }
};


void main( void ) {
   StackInt s;
   for (int i=0; i < 10; i++)
      s.push( i );
   while ( ! s.isEmpty())
      cout << s.pop() << ' ';
   cout << '\n';
}
// 9 8 7 6 5 4 3 2 1 0

/*
//#if 0

void main( void ) {
   Stack<int>     s1;
   Stack<char>    s2;
   Stack<string>  s3;
   stringstream  ss;
   for (int i=0; i < 10; i++) {
      s1.push( i );
      s2.push( 'a' + i );
      ss << "str" << i;
      s3.push( ss.str() );
      ss.str( "" );
   }
   while ( ! s1.isEmpty()) cout << s1.pop() << ' ';
   cout << '\n';
   while ( ! s2.isEmpty()) cout << s2.pop() << ' ';
   cout << '\n';
   while ( ! s3.isEmpty()) cout << s3.pop() << ' ';
   cout << '\n';
}

// 9 8 7 6 5 4 3 2 1 0
// j i h g f e d c b a
// str9 str8 str7 str6 str5 str4 str3 str2 str1 str0

//#endif
*/