// Purpose.  Class template with layers lab
//
// Assignment.
// o Rework Node and Queue so that they are decoupled from the type of
//   element they contain
// o Replace the first main() with the second main() and fix the "???"
//   declarations
// o Add two #include's

// faire tourner le premier main
// templatiser Node et Queue
// Attention aux types Node<T> de la classe Queue
// ajouter <sstream> qui inclut <string> 

#include <iostream>
#include <sstream>
using namespace std;


struct Node {
   int value;
   Node* next;
   Node( int val ) { value = val;  next = 0; }
   ~Node()         { cout << value << "-gone  "; }
};


class Queue {
   Node *head, *tail;
public:
   Queue() { head = tail = 0; }
   void put( int val ) {
      if (tail) {
         tail->next = new Node( val );
         tail = tail->next;
      } else
         head = tail = new Node( val );
   }
   int get() {
      int ret = head->value;
      Node* going = head;
      head = head->next;
      delete going;
      return ret;
   }
   bool isEmpty() { return head == 0; }
};

/*void main( void ) {
   Queue que;
   for (int i=1; i < 7; i++)
      que.put( i );
   while ( ! que.isEmpty())
      cout << que.get() << '\n';
}
*/
// 1-gone  1
// 2-gone  2
// 3-gone  3
// 4-gone  4
// 5-gone  5
// 6-gone  6


//#if 0

void main( void ) {
   Queue que1;
   //Queue<string> que2;
   stringstream  ss;
   for (int i=1; i < 7; i++) {
      que1.put( i );
      ss.str( "" );
      ss << "str" << i;
      //que2.put( ss.str() );
   }
   while ( ! que1.isEmpty())
      cout << que1.get() << "  ";// << que2.get() << '\n';
}

// str1-gone  1-gone  1  str1
// str2-gone  2-gone  2  str2
// str3-gone  3-gone  3  str3
// str4-gone  4-gone  4  str4
// str5-gone  5-gone  5  str5
// str6-gone  6-gone  6  str6

//#endif
