// Purpose.  STL lab
//
// Assignment.
// o Take you stackTemplateLab answer and replace the dynamic array with a
//   standard library container class

//Intrt : Mapper des mthodes publies, sur un conteneur de la STL
// le problme avec le tableau est que la profondeur est fige
// le vector permet de se dbarasser du "sp" et de la mthode isFull
//inclusion du stackTemplate et du "main"
// on peut retirer les "sp et size"
// on remplace le tableau par un vecteur (renommer array en vect)
// la mthode isFull rendra toujours false
// plus besoin de destructeur
// attention au pop_back qui ne renvoie pas la dernire valeur... mais la perd
// il convient donc de la mmoriser dans une variable "der" que l'on renvoie
// pour conserver la smantique du Ctor, on pourra utiliser "reserve"

#pragma warning( disable : 4786 )
#include <iostream>
#include <vector>
#include <string>
#include <sstream>
using namespace std;


//inclusion du "main"
void main( void ) {
   Stack<int>     s1;
   Stack<char>    s2;
   Stack<string>  s3;
   stringstream  ss;
   for (int i=0; i < 10; i++) {
      s1.push( i );
      s2.push( 'a' + i );
      ss << "str" << i;
      s3.push( ss.str() );
      ss.str( "" );
   }
   while ( ! s1.isEmpty()) cout << s1.pop() << ' ';
   cout << '\n';
   while ( ! s2.isEmpty()) cout << s2.pop() << ' ';
   cout << '\n';
   while ( ! s3.isEmpty()) cout << s3.pop() << ' ';
   cout << '\n';
}

// 12 11 10 9 8 7 6 5 4 3 2 1 0
// m l k j i h g f e d c b a
// str12 str11 str10 str9 str8 str7 str6 str5 str4 str3 str2 str1 str0
