// Purpose.  container class lab
//
// Discussion.  We want to maintain a "collection" of Persons that can support
// a round-robin bidding process.  Membership in the collection means the
// Person's limit has not been exceeded.  The next bidder is always at the
// "front" of the collection.  When the size of the collection dwindles to
// one, the auction is complete.
//
// Assignment.
// o Decide on the best collection class to use
// o Create an instance of that class in main()
// o Populate the collection with the following people/limit: Fred/15,
//   Ricky/17, Ethel/21, Lucy/23
// o Don't modify struct Person
// o Start the bidding at 11

// Comme les porteurs d'enchres peuvent tre amens  quitter le jeu  n'importe quel moment
// et dans n'importe quel ordre, il est conseill d'utiliser une liste chane
// vu le pgm principal, il faut une liste de Personne*

// comprendre l'algorithme dsir :
// d'abord initialiser la liste avec les Personnes (chacun a un max d'enchre)
// les enchres commencent  11
// tant qu'il y a plus d'une personne dans la liste :
//    si la personne en dbut de liste a un MAX infrieur  l'enchre courante, elle est limine
//    sinon, elle peut sur-enchrir de 1 et elle doit passer  la queue
//		  crowd.push_back(crowd.front());
// Ne pas oublier de faire appel aux destructeurs


#include <iostream>
#include <string>
#include <list>
using namespace std;

struct Person {
   string name;
   int    limit;
   Person( string n, int l ) { name = n;  limit = l; }
   ~Person() { cout << "   " << name << " retires\n"; }
};

void main( void ) {
   
}

// Fred bids 11
// Ricky bids 12
// Ethel bids 13
// Lucy bids 14
// Fred bids 15
// Ricky bids 16
// Ethel bids 17
// Lucy bids 18
//    Fred retires
//    Ricky retires
// Ethel bids 19
// Lucy bids 20
// Ethel bids 21
// Lucy bids 22
//    Ethel retires
// Lucy wins at 22
//    Lucy retires
