// Purpose.  container class lab answer

#include <iostream>
#include <list>
#include <string>
using namespace std;

struct Person {
   string name;
   int    limit;
   Person( string n, int l ) { name = n;  limit = l; }
   ~Person() { cout << "   " << name << " retires\n"; }
};

void main( void ) {
   list<Person*> crowd;
   int bid = 10;
   crowd.push_back( new Person("Fred", 15) );
   crowd.push_back( new Person("Ricky",17) );
   crowd.push_back( new Person("Ethel",21) );
   crowd.push_back( new Person("Lucy", 23) );
   while (crowd.size() > 1) 
      if (bid > crowd.front()->limit) {
         delete crowd.front();
         crowd.pop_front();
      } else {
         cout << crowd.front()->name << " bids " << ++bid << '\n';
         crowd.push_back( crowd.front() );
         crowd.pop_front();
      }
   cout << crowd.front()->name << " wins at " << bid << '\n';
   delete crowd.front();
}

// Fred bids 11
// Ricky bids 12
// Ethel bids 13
// Lucy bids 14
// Fred bids 15
// Ricky bids 16
// Ethel bids 17
// Lucy bids 18
//    Fred retires
//    Ricky retires
// Ethel bids 19
// Lucy bids 20
// Ethel bids 21
// Lucy bids 22
//    Ethel retires
// Lucy wins at 22
//    Lucy retires
