// Purpose.  deque lab answer

#pragma warning( disable : 4786 )
#include <iostream>
#include <deque>
#include <string>
#include <sstream>
using namespace std;

template <typename YYY>
class Queue {
   deque<YYY> que;
public:
   void put( YYY val ) { que.push_back( val ); }
   YYY get() {
      YYY ret = que.front();
      que.pop_front();
      return ret;
   }
   bool isEmpty() { return que.size() == 0; }
};

void main( void ) {
   Queue<int>    que1;
   Queue<string> que2;
   stringstream  ss;
   for (int i=1; i < 7; i++) {
      que1.put( i );
      ss.str( "" );
      ss << "str" << i;
      que2.put( ss.str() );
   }
   while ( ! que1.isEmpty())
      cout << que1.get() << "  " << que2.get() << '\n';
}

// 1  str1
// 2  str2
// 3  str3
// 4  str4
// 5  str5
// 6  str6
