// Purpose.  auto_ptr initialization, usage, and cleanup lab answer

#include <iostream>
#include <memory>
using namespace std;

class A {
   int id;
   static int next;
public:
   A() { id = next++;  cout << 'A' << id << ' '; }
   ~A() { cout << 'd' << id << ' '; }
   void foo() { cout << "foo-" << id << ' '; }
};

int A::next = 1;

void main( void ) {
   auto_ptr<A> array[3];
   for (int i=0; i < 3; i++)
      array[i] = auto_ptr<A>( new A() );
   cout << '\n';
   for (i=0; i < 3; i++)
      array[i]->foo();
   cout << '\n';
}

// A1 A2 A3
// foo-1 foo-2 foo-3
// d3 d2 d1 Press any key to continue
