#define N 1
#include <iostream>
#include <string>
using namespace std;
/*
I) crer un pgm simple permettant de saisir une opration
 ainsi que deux nombres (les oprandes)
dfinir les fonctions 'plus' et 'moins'
tester avec un 'if' le symbole (+,-) de l'opration entre
 et l'invoquer avec les oprandes 
afficher l'opration et le rsultat ainsi :
12 + 10 = 22

II) modifier le pgm pour utiliser un pointeur de fonction sur l'opration
dfinir le pointeur de fonction
tester le symbole et invoquer la fonction par son pointeur.

III) faire une <map> de pointeurs dont la clef est le 'char' operation

tendre le pgm pour supporter les fonctions '*' et '/' supplmentaires 

 
*/

#if N==1
//programme classique
int plus(int x, int y){return x+y;}
int moins(int x, int y){return x-y;}
int main()
{
	string oper;
	int resultat=0;
	int n1=0, n2=0;
	cout << "entrer deux nombres (operandes) entiers" << endl;
	cin >> n1 >> n2;
	if (cin.bad())
	{
		cout << "entree incorrecte ! " << endl;
		return 1;
	}
	cout << "entrer une opration ('+' ou '-')" << endl;
	cin >> oper;
	if (oper=="+")
		resultat = plus(n1, n2);
	else if (oper=="-")
		resultat = moins(n1, n2);
	else
	{
		cout << "fonction inconnue ! " << endl;
		return 1;
	}
	cout << n1 << oper << n2 << " = " << resultat << endl;

	return 0;
	}

#elif N==2
//pointeur de fonction
typedef int (*PF)(int, int);
PF fn = 0;
int call(PF fonction, int arg1, int arg2)
	{return fonction(arg1, arg2);}
int plus(int x, int y){return x+y;}
int moins(int x, int y){return x-y;}
int fois(int x, int y){return x*y;}
int divise(int x, int y){return x/y;}

int main()
{
	string oper;
	int resultat=0;
	int n1=0, n2=0;
	cout << "entrer deux nombres (operandes) entiers" << endl;
	cin >> n1 >> n2;
	if (cin.bad())
	{
		cout << "entree incorrecte ! " << endl;
		return 1;
	}
	cout << "entrer une opration ('+' ou '-')" << endl;
	cin >> oper;
	if (oper=="+")
		fn = plus;
	else if (oper=="-")
		fn = moins;
	else if (oper=="*")
		fn = fois;
	else if (oper=="/")
		fn = divise;
	else
	{
		cout << "fonction inconnue ! " << endl;
		return 1;
	}
	resultat = fn(n1,n2);
	cout << n1 << oper << n2 << " = " << resultat << endl;

	return 0;
	}

#elif N==3
//tableau de pointeurs de fonction
int plusJL(int x, int y){return x+y;}
int moins(int x, int y){return x-y;}
int fois(int x, int y){return x*y;}
int divise(int x, int y){return x/y;}

typedef int (*PF)(int, int);
//PF fn[4] = {plus, moins, fois, divise};
int call(PF fonction, int arg1, int arg2)
	{return fonction(arg1, arg2);}
#include <map>

int main()
{
	map<char, PF> operation;
	//operation.insert(make_pair('+', &plusJL));
	operation['+']=plusJL;
	operation['-']=moins;
	operation['*']=fois;
	operation['/']=divise;

	char oper;
	int resultat=0;
	int n1=0, n2=0;
	cout << "entrer deux nombres (operandes) entiers" << endl;
	cin >> n1 >> n2;
	if (cin.bad())
	{
		cout << "entree incorrecte ! " << endl;
		return 1;
	}
	cout << "entrer une opration ('+' ou '-') ..." << endl;
	cin >> oper;
/*	PF fn = operation[oper];
	if (fn==0)
	{
		cout << "fonction inconnue ! " << endl;
		return 1;
	}
*/
	resultat = operation[oper](n1,n2);
	cout << n1 << oper << n2 << " = " << resultat << endl;

	return 0;
	}
#endif
