// Purpose.  Generic programming lab answer (sequence)

#include <iostream>
#include <vector>
#include <ctime>
using namespace std;

// Shell sort, Stroustrup, p334
template <typename TBD>
void sort( TBD v, TBD end ) {
   int n = distance( v, end );
   for (int g = n/2; g > 0; g /= 2)
      for (int i = g; i < n; i++)
         for (int j = i-g; j >= 0; j -= g)
            if (v[j] > v[j+g])
               swap( v[j], v[j+g] );
}

void main( void ) {
   srand( time(0) );
   const int NUM = 15;
   int array[NUM], array2[NUM];
   for (int i=0; i < NUM; i++) array[i] = rand() % 20 + 1;
   memcpy( array2, array, sizeof(int) * NUM );
   for (i=0; i < NUM; i++) cout << array[i] << ' ';   cout << '\n';
   sort( array, array+NUM );
   for (i=0; i < NUM; i++) cout << array[i] << ' ';   cout << '\n';

   vector<int>  vec( array2, array2+NUM );
   for (i=0; i < NUM; i++) cout << vec[i] << ' ';     cout << '\n';
   sort( vec.begin(), vec.end() );
   for (i=0; i < NUM; i++) cout << vec[i] << ' ';     cout << '\n';
}

// 12 17 6 13 16 20 9 1 2 6 6 3 12 4 9
// 1 2 3 4 6 6 6 9 9 12 12 13 16 17 20
// 12 17 6 13 16 20 9 1 2 6 6 3 12 4 9
// 1 2 3 4 6 6 6 9 9 12 12 13 16 17 20
