// Purpose.  Exception escaping from destructor lab answer

#include <iostream>
#include <fstream>
#include <string>
using namespace std;

class A {
public:
   A() { cout << "A ctor\n"; }
   ~A() {
      try {
         cout << "dtor A\n";
         throw 321;
      } catch (...) {
         cout << "exception almost slipped by\n";
}  }  };

void myTerminate() {
   cout << "myTerminate: failed to catch exception\n";
   exit( 1 );
}

void foo() {
   A obj;
   throw 123;
}

void main( void ) {
   set_terminate( myTerminate );
   try {
      foo();
   } catch (int ex) {
      cout << "exception - " << ex << '\n';
}  }

// A ctor
// dtor A
// exception almost slipped by
// exception - 123
